/* 
 * Program:             $RCSfile: AR3.h,v $  $Revision: 30.19 $
 * 
 * Purpose:             Header of AR3 (Sapid Access Routines ver. 3).
 * 
 * Author:              K.Hayashi  1995/02/20
 *                      S.Yamamoto  1995/02/24
 * 
 * (C) Copyright:       K.Hayashi and S.Yamamoto  1995 - 2003
 *                      This file is a product of the project Sapid.
 */

#if !defined(_SPD_AR3_H) && defined(SAPID_AR3)
#define _SPD_AR3_H

/*
 *                      Attributes values.
 */

#include <Sapid/AR3Attr.h>
#include <Sapid/AR3AttrId.h>

/******************************************************************************/

/*
 *                      Macros (added by S.Yamamoto 2003/04/07).
 */

/* Max number of integer attributes in a object record. */

#define SpdObjIValN     7

/* Max number of string attributes in a object record. */

#define SpdObjSValN     2

/* Max number of integer attributes in a relationship record. */

#define SpdRelIValN     6

/* Max number of string attributes in a relationship record. */

#define SpdRelSValN     0

/* Data type of attributes. */

typedef enum _SpdDBType {
    SPD_DBT_NON = -1, SPD_DBT_INT, SPD_DBT_STR, SPD_DBT_ENUM, SPD_DBT_OID
} SpdDBType;

/******************************************************************************/

/*
 *                      Models.
 */

typedef struct _SpdDBModel_t    SpdDBModel;

#include <Sapid/SapidModelId.h>

#ifdef SAPID_AR3_KERNEL
#include "AR3Sub.h"
#endif

typedef struct {
    SpdObjId    objectId;
    SpdRelId    relationId;
} SpdRel;

typedef struct {
    SpdObjId    fileId;
    SpdObjId    objectId;
    int         offset;
    SpdRelId    relationId;
} SpdOcc;

typedef struct {
    SpdObjId    fileId;
    int         offset;
    int         length;
} SpdRegion;

/*
 * Block_Table:
 *     pblockμֹ桤ΥեåȡĹʤ3ȡ
 *     !! SpdPblockEntryŬڤ̾
 *     !! SpdRegionΥФfileIdidѹСSpdRegionȶѤǤ롥
 * 
 * All_Block_Table:
 *     offsetpblock®˸뤿Ѥ롤ե
 *     pblockoffset¤٤ǥå
 *     !! SpdPblockTableŬڤ̾
 */

typedef struct {
    SpdObjId    id;                         /* Id of the pblock instance. */
    int         offset;                     /* Its offset. */ 
    int         length;                     /* Its length. */ 
} Block_Table;

#if defined(SAPID_AR4_KERNEL)

typedef struct {
    SpdObjId        fileId;
    Block_Table     *block_table;
    int             block_table_n;
} All_Block_Table;

#endif /* defined(SAPID_AR4_KERNEL) */

#endif /* !defined(_SPD_AR3_H) && defined(SAPID_AR3) */
