/* 
 * Program:             $RCSfile: AreaModel.h,v $  $Revision: 30.18 $
 * 
 * Purpose:             AreaModel饹
 * 
 * Author:              T.Hidaka  1998/05/21
 *                      S.Yamamoto  1998/05/23
 * 
 * (C) Copyright:       T.Hidaka and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

/*
 * $Id: AreaModel.h,v 30.18 2003/06/22 14:41:38 yamamoto Exp yamamoto $
 */

#ifndef _SAPID_AREA_MODEL_H
#define _SAPID_AREA_MODEL_H

/* Class id. */

#define SPD_CID_STORAGE             (SPD_FIRST_CID_AREA_MODEL + 0)
#define SPD_CID_AREA                (SPD_FIRST_CID_AREA_MODEL + 1)
#define SPD_CID_VALUE               (SPD_FIRST_CID_AREA_MODEL + 2)

#if (SPD_CID_VALUE != SPD_LAST_CID_AREA_MODEL)
    "Invalid configuration."
#endif

#define SPD_CID_NUM_AREA_MODEL \
        (SPD_LAST_CID_AREA_MODEL - SPD_FIRST_CID_AREA_MODEL + 1)

/* Relation id. */

#define SPD_RID_STORAGE_STORAGE     (SPD_FIRST_RID_AREA_MODEL + 0)
#define SPD_RID_STORAGE_AREA        (SPD_FIRST_RID_AREA_MODEL + 1)
#define SPD_RID_AREA_AREA           (SPD_FIRST_RID_AREA_MODEL + 2)
#define SPD_RID_AREA_VALUE          (SPD_FIRST_RID_AREA_MODEL + 3)
#define SPD_RID_POINT_TO            (SPD_FIRST_RID_AREA_MODEL + 4)
#define SPD_RID_FUNCPTR_TO          (SPD_FIRST_RID_AREA_MODEL + 5)
#define SPD_RID_PROG_STORAGE        (SPD_FIRST_RID_AREA_MODEL + 6)
#define SPD_RID_FUNC_STORAGE        (SPD_FIRST_RID_AREA_MODEL + 7)
#define SPD_RID_BLOCK_STORAGE       (SPD_FIRST_RID_AREA_MODEL + 8)
#define SPD_RID_VARIABLE_AREA       (SPD_FIRST_RID_AREA_MODEL + 9)
#define SPD_RID_MEMBER_AREA         (SPD_FIRST_RID_AREA_MODEL + 10)
#define SPD_RID_STRING_AREA         (SPD_FIRST_RID_AREA_MODEL + 11)
#define SPD_RID_AREA_TYPE           (SPD_FIRST_RID_AREA_MODEL + 12)
#define SPD_RID_VALUE_TYPE          (SPD_FIRST_RID_AREA_MODEL + 13)
#define SPD_RID_VALUE_ENUM          (SPD_FIRST_RID_AREA_MODEL + 14)

#if (SPD_RID_VALUE_ENUM != SPD_LAST_RID_AREA_MODEL)
    "Invalid configuration."
#endif

#define SPD_RID_NUM_AREA_MODEL \
        (SPD_LAST_RID_AREA_MODEL - SPD_FIRST_RID_AREA_MODEL + 1)

/* Number of all classes and relations. */

#define SPD_CRID_NUM_AREA_MODEL \
        (SPD_CID_NUM_AREA_MODEL + SPD_RID_NUM_AREA_MODEL)

/******************************************************************************/

/* 
 * Attribute values.
 * "AR3Attr.h"Ⱦͤ뤿"STORAGE_XXX"ϻȤʤ
 */

#define AREA_STORAGE_GLOBAL     0
#define AREA_STORAGE_FUNC       1   /* !! storage_storageζڤ˻Ȥ */
#define AREA_STORAGE_LOCAL      2
#define AREA_STORAGE_HEAP       3

#define AREA_BASIC              0
#define AREA_STRUCT             1
#define AREA_UNION              2
#define AREA_ARRAY              3

#define AREA_INDIRECT           0
#define AREA_DIRECT             1

#define VALUE_NONVALUE          0
#define VALUE_BASIC             1
#define VALUE_POINTER           2
#define VALUE_FUNCPOINTER       3
#define VALUE_REALPOINTER       4
#define VALUE_ENUM              5
#define VALUE_INTEGER           6
#define VALUE_UINTEGER          7

/******************************************************************************/

#define SPD_AREA_MODEL_VERSION      1

extern SpdDBModel Area_model;

#endif /* _SAPID_AREA_MODEL_H */
