/* 
 * Program:             $RCSfile: AreaModelAR.h,v $  $Revision: 30.22 $
 * 
 * Purpose:             AreaModelAR.
 * 
 * Author:              T.Hidaka  1998/05/21
 *                      S.Yamamoto  1998/05/23
 * 
 * (C) Copyright:       T.Hidaka and S.Yamamoto  1998 - 2000
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: AreaModelAR.h,v 30.22 2003/07/08 06:19:48 yamamoto Exp yamamoto $
 */ 

#ifndef _SAPID_AREA_MODEL_AR_H
#define _SAPID_AREA_MODEL_AR_H

/*
 * Type declarations.
 */

typedef struct SpdValueData_t{
    enum SpdValueType {
        SpdValue_NonValue = VALUE_NONVALUE,
        SpdValue_Integer = VALUE_INTEGER,
        SpdValue_Unsigned_Integer = VALUE_UINTEGER,
        /* SpdValue_Double, !! Not supported yet. */
        SpdValue_Pointer = VALUE_POINTER,
        SpdValue_FuncPointer = VALUE_FUNCPOINTER,
        SpdValue_RealPointer = VALUE_REALPOINTER
    } type;
    union {
        int intval;
        unsigned int uintval;
        void *pointerval;   /* !! "sizeof(int) == sizeof(void *)" assumed. */
        /* double doubleval; !! Not supported yet. */
        struct {
            SpdObjId areaId;
            int offset;
        } ptr;
        SpdObjId funcId;
    } v;
} SpdValueData;

/*
 * Prototypes.
 */

void spdarea_setOrder(SpdRelId relId);
int spdCastValueDataInt(SpdValueData value);
SpdValueData spdEvalConstExpression(SpdObjId cexprId);

SpdObjId spdCreateConstantStringArea(SpdObjId stringId, SpdObjId storageId);
SpdObjId spdSetConstantStringArea(SpdObjId areaId, SpdObjId stringId);
SpdObjId spdCreateStringArea(SpdConstString str, SpdObjId storageId);
SpdObjId spdSetStringArea(SpdObjId areaId, SpdConstString str);
SpdObjId spdCreateArea(SpdObjId typeId);
SpdObjId spdCreateArrayArea(SpdObjId typeId, int n);
SpdObjId spdCreateVariableArea(SpdObjId variableId, SpdObjId storageId);
SpdObjId spdCreateStorage(SpdObjId blockId);
SpdObjId spdCreateStorageArea(SpdObjId blockId);
SpdObjId spdCreateGlobalStorage(SpdObjId programId);
SpdValueData spdConvRealPtrToAreaPtr(SpdValueData value);
SpdObjId spdCreateValue(SpdValueData value);
void spdDeleteArea(SpdObjId areaId);
void spdDeleteStorageArea(SpdObjId storageId);

SpdObjId spdGetVariableArea(SpdObjId variableId);
SpdObjId spdGetMemberArea(SpdObjId areaId, SpdObjId memberId);
SpdObjId spdGetArrayElementArea(SpdObjId areaId, int index);

SpdObjId spdSetValue(SpdObjId areaId, SpdObjId valueId);
SpdObjId spdSetValueData(SpdObjId areaId, SpdValueData value);
SpdObjId spdInitializeAreaValue(SpdObjId areaId);
SpdObjId spdGetValue(SpdObjId areaId, int time);
SpdValueData spdGetValueData(SpdObjId areaId, int time);
SpdValueData spdGetValueDataFromValue(SpdObjId valueId);
SpdValueData spdGetFuncNameValueData(SpdObjId funcId);

void spdEnableStorage(SpdObjId storageId);
SpdObjId spdDisableStorage(void);
SpdObjId spdSetCurrentStorage(SpdObjId storageId);
SpdObjId spdGetCurrentStorage(void);
SpdObjId spdSetGlobalStorage(SpdObjId storageId);
SpdObjId spdGetGlobalStorage(void);

/* Added by S.Yamamoto 2000/03/24. */
void spdarea_initOrder(SpdObjId parentId);

#endif /* _SAPID_AREA_MODEL_AR_H */
