/* 
 * Program:             $RCSfile: Bmodel.h,v $  $Revision: 30.10 $
 * 
 * Purpose:             Class definition of B-model.
 * 
 * Author:              T.Hidaka and S.Yamamoto  1998/03/15
 * 
 * (C) Copyright:       T.Hidaka and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: Bmodel.h,v 30.10 2003/02/20 15:12:44 yamamoto Exp yamamoto $
 */ 

#ifndef _SAPID_B_MODEL_H
#define _SAPID_B_MODEL_H

/* Class id. */

#define SPD_CID_EXECUTION           (SPD_FIRST_CID_B_MODEL + 0)
#define SPD_CID_OPERATION           (SPD_FIRST_CID_B_MODEL + 1)

#if (SPD_CID_OPERATION != SPD_LAST_CID_B_MODEL)
    "Invalid configuration."
#endif

#define SPD_CID_NUM_B_MODEL \
        (SPD_LAST_CID_B_MODEL - SPD_FIRST_CID_B_MODEL + 1)

/* Relation id. */

#define SPD_RID_PROG_EXEC           (SPD_FIRST_RID_B_MODEL + 0)
#define SPD_RID_EXEC_OP             (SPD_FIRST_RID_B_MODEL + 1)
#define SPD_RID_STATEMENT_OP        (SPD_FIRST_RID_B_MODEL + 2)
#define SPD_RID_ALLOC_STORAGE       (SPD_FIRST_RID_B_MODEL + 3)
#define SPD_RID_FREE_STORAGE        (SPD_FIRST_RID_B_MODEL + 4)
#define SPD_RID_DEFINE_VALUE        (SPD_FIRST_RID_B_MODEL + 5)
#define SPD_RID_REFER_VALUE         (SPD_FIRST_RID_B_MODEL + 6)
#define SPD_RID_CALL_VALUE          (SPD_FIRST_RID_B_MODEL + 7)
#define SPD_RID_RETURN_VALUE        (SPD_FIRST_RID_B_MODEL + 8)
#define SPD_RID_BRANCH_VALUE        (SPD_FIRST_RID_B_MODEL + 9)
#define SPD_RID_DEPEND_ON           (SPD_FIRST_RID_B_MODEL + 10)
#define SPD_RID_CALL_FUNC           (SPD_FIRST_RID_B_MODEL + 11)
#define SPD_RID_CALL_RETURN         (SPD_FIRST_RID_B_MODEL + 12)
#define SPD_RID_ENTRY_EXIT          (SPD_FIRST_RID_B_MODEL + 13)

#if (SPD_RID_ENTRY_EXIT != SPD_LAST_RID_B_MODEL)
    "Invalid configuration."
#endif

#define SPD_RID_NUM_B_MODEL \
        (SPD_LAST_RID_B_MODEL - SPD_FIRST_RID_B_MODEL + 1)

/* Number of all classes and relations. */

#define SPD_CRID_NUM_B_MODEL \
        (SPD_CID_NUM_B_MODEL + SPD_RID_NUM_B_MODEL)

/******************************************************************************/

#define OPERATION_ALLOC             0
#define OPERATION_FREE              1
#define OPERATION_DEFINE            2
#define OPERATION_REFER             3
#define OPERATION_CALL              4
#define OPERATION_RETURN            5
#define OPERATION_BRANCH            6
#define OPERATION_ENTRY             7
#define OPERATION_EXIT              8

/******************************************************************************/

#define SPD_B_MODEL_VERSION         1

extern SpdDBModel B_model;

#endif /* not _SAPID_B_MODEL_H */
