/* 
 * Program:             $RCSfile: Dmodel.h,v $  $Revision: 30.13 $
 * 
 * Purpose:             Class definition of D-model.
 * 
 * Author:              N.Koyama  2000/03/16
 *                      S.Yamamoto  2000/03/16
 * 
 * (C) Copyright:       N.Koyama and S.Yamamoto  2000 - 2003
 *                      This file is a product of the project Sapid.
 */

#if !defined(_SAPID_D_MODEL_H)
#define _SAPID_D_MODEL_H

/* Class id. */

#define SPD_CID_SOFTWARE            (SPD_FIRST_CID_D_MODEL + 0)
#define SPD_CID_DOCUMENT            (SPD_FIRST_CID_D_MODEL + 1)
#define SPD_CID_DOCFILE             (SPD_FIRST_CID_D_MODEL + 2)
#define SPD_CID_DOCFRAG             (SPD_FIRST_CID_D_MODEL + 3)
#define SPD_CID_TEXTSTRING          (SPD_FIRST_CID_D_MODEL + 4)
#define SPD_CID_ATTRIBUTE           (SPD_FIRST_CID_D_MODEL + 5)
#define SPD_CID_DOCIDENT            (SPD_FIRST_CID_D_MODEL + 6)

#if (SPD_CID_DOCIDENT != SPD_LAST_CID_D_MODEL)
    "Invalid configuration."
#endif

#define SPD_CID_NUM_D_MODEL \
        (SPD_LAST_CID_D_MODEL - SPD_FIRST_CID_D_MODEL + 1)

/* Relation id. */

#define SPD_RID_SOFT_DOC            (SPD_FIRST_RID_D_MODEL + 0)
#define SPD_RID_SOFT_PROG           (SPD_FIRST_RID_D_MODEL + 1)
#define SPD_RID_DOC_DOCFILE         (SPD_FIRST_RID_D_MODEL + 2)
#define SPD_RID_DOCFILE_DOCFRAG     (SPD_FIRST_RID_D_MODEL + 3)
#define SPD_RID_DOCELEM_DOCFRAG     (SPD_FIRST_RID_D_MODEL + 4)
/* #define SAPID_REL_D_BASICELEM_ATTRIBUTE (SPD_FIRST_RID_D_MODEL + 5) */
#define SPD_RID_DOCELEM_ATTRIBUTE   (SPD_FIRST_RID_D_MODEL + 5)
#define SPD_RID_ATTRIBUTE_VALUE     (SPD_FIRST_RID_D_MODEL + 6)
#define SPD_RID_TEXTFRAG_TEXTSTRING (SPD_FIRST_RID_D_MODEL + 7)
#define SPD_RID_DEFELEM_DOCIDENT    (SPD_FIRST_RID_D_MODEL + 8)
#define SPD_RID_IDENTELEM_DOCIDENT  (SPD_FIRST_RID_D_MODEL + 9)
#define SPD_RID_SRCELEM_SRCFRAG     (SPD_FIRST_RID_D_MODEL + 10)
#define SPD_RID_DOCIDENT_IDENTIFIER (SPD_FIRST_RID_D_MODEL + 11)
#define SPD_RID_LINKELEM_SRCFRAG    (SPD_FIRST_RID_D_MODEL + 12)

#if (SPD_RID_LINKELEM_SRCFRAG != SPD_LAST_RID_D_MODEL)
    "Invalid configuration."
#endif
    
#define SPD_RID_NUM_D_MODEL \
        (SPD_LAST_RID_D_MODEL - SPD_FIRST_RID_D_MODEL + 1)

/* Number of all classes and relations. */

#define SPD_CRID_NUM_D_MODEL \
        (SPD_CID_NUM_D_MODEL + SPD_RID_NUM_D_MODEL)

/******************************************************************************/

/* Attributes. */

/* docfrag. */

#define DOCFRAG_TEXTFRAG    (1 << 0)
#define DOCFRAG_BASICELEM   (1 << 1)
#define DOCFRAG_DEFELEM     (1 << 2)
#define DOCFRAG_LINKELEM    (1 << 3)
#define DOCFRAG_IDENTELEM   (1 << 4)
#define DOCFRAG_SRCELEM     (1 << 5)
#define DOCFRAG_MACROELEM   (1 << 6)

#define DOCFRAG_DOCELEM     (DOCFRAG_BASICELEM | \
                             DOCFRAG_DEFELEM | \
                             DOCFRAG_LINKELEM | \
                             DOCFRAG_MACROELEM )

#define DOCFRAG_DOCFRAG     (DOCFRAG_TEXTFRAG | \
                             DOCFRAG_DOCELEM | \
                             DOCFRAG_IDENTELEM | \
                             DOCFRAG_SRCELEM )
/* docident. */
/* Same value as identifier (for mkDmodel). */

#define DID_VARIABLE        (1 << 0)
#define DID_FUNCTION        (1 << 1)
#define DID_MEMBER          (1 << 2)
#define DID_ENUMERATOR      (1 << 3)
#define DID_TYPENAME        (1 << 4)
#define DID_TAG             (1 << 5)
#define DID_DOCIDENT        (1 << 6)
#define DID_UNKNOWN         (1 << 7)
#define DID_MACRONAME       (1 << 8)
#define DID_FILE            (1 << 9)


#if (DID_VARIABLE != ID_VARIABLE || \
     DID_FUNCTION != ID_FUNCTION || \
     DID_MEMBER != ID_MEMBER || \
     DID_ENUMERATOR != DID_ENUMERATOR || \
     DID_TYPENAME != DID_TYPENAME || \
     DID_TAG != DID_TAG)
    "Invalid configuration."
#endif

/* Attribute id. */

#define DPD_AID_DOCUMENT_NAME \
    spdGetAttrIdByName3(DAPID_CLASS_DOCUMENT, NULL, "name")

#define DPD_AID_DOCIDENT_NAME \
    spdGetAttrIdByName3(DAPID_CLASS_DOCIDENT, NULL, "name")

#define DPD_AID_DOCFRAG_SORT \
    spdGetAttrIdByName3(DAPID_CLASS_DOCFRAG, NULL, "sort")

#define DPD_AID_DOCIDENT_SORT \
    spdGetAttrIdByName3(DAPID_CLASS_DOCIDENT, NULL, "sort")

/******************************************************************************/

#define SPD_D_MODEL_VERSION         1

extern SpdDBModel D_model;

#endif /* !defined(_SAPID_D_MODEL_H) */
