/* 
 * Program:             $RCSfile: FlowView.h,v $  $Revision: 40.3 $
 * 
 * Purpose:
 *
 * Author:              T.Saso  2001/11/17
 *                      S.Yamamoto  2001/11/17
 *
 * (C) Copyright:       T.Saso and S.Yamamoto  2001 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef _SPD_FLOW_VIEW_H
#define _SPD_FLOW_VIEW_H

/* Class id. */

#define SPD_CID_BLK_ENTRY       (SPD_FIRST_CID_FLOW_VIEW + 0)
#define SPD_CID_BLK_GO_INTO     (SPD_FIRST_CID_FLOW_VIEW + 1)
#define SPD_CID_BLK_EXIT        (SPD_FIRST_CID_FLOW_VIEW + 2)
#define SPD_CID_BLK_BREAK       (SPD_FIRST_CID_FLOW_VIEW + 3)
#define SPD_CID_BLK_CONTINUE    (SPD_FIRST_CID_FLOW_VIEW + 4)
#define SPD_CID_BLK_GO_AWAY     (SPD_FIRST_CID_FLOW_VIEW + 5)
#define SPD_CID_BLK_RETURN      (SPD_FIRST_CID_FLOW_VIEW + 6)
#define SPD_CID_SWITCH_BRANCH   (SPD_FIRST_CID_FLOW_VIEW + 7)

#if (SPD_CID_SWITCH_BRANCH != SPD_LAST_CID_FLOW_VIEW)
    "Invalid configuration."
#endif

#define SPD_CID_NUM_FLOW_VIEW \
        (SPD_LAST_CID_FLOW_VIEW - SPD_FIRST_CID_FLOW_VIEW + 1)

/* Relation id. */

#define SPD_RID_NEXT_NODE       (SPD_FIRST_RID_FLOW_VIEW + 0)
#define SPD_RID_BLK_SDANODE     (SPD_FIRST_RID_FLOW_VIEW + 1)
#define SPD_RID_DATA_DEPENDENCE (SPD_FIRST_RID_FLOW_VIEW + 2)
#define SPD_RID_DEF_USED        (SPD_FIRST_RID_FLOW_VIEW + 3)

#if (SPD_RID_DEF_USED != SPD_LAST_RID_FLOW_VIEW)
    "Invalid configuration."
#endif

#define SPD_RID_NUM_FLOW_VIEW \
        (SPD_LAST_RID_FLOW_VIEW - SPD_FIRST_RID_FLOW_VIEW + 1)

/* Number of all classes and relations. */

#define SPD_CRID_NUM_FLOW_VIEW \
        (SPD_CID_NUM_FLOW_VIEW + SPD_RID_NUM_FLOW_VIEW)

/* Temporarily. */
#define SPD_CID_SDA5_ANY_NODE   SPD_FIRST_CID_FLOW_VIEW

/******************************************************************************/

/* blk_sort */

#define SPD_FV_B_FUNC       0
#define SPD_FV_B_COMP       1
#define SPD_FV_B_IF     2
#define SPD_FV_B_SWITCH     3
#define SPD_FV_B_FOR        4
#define SPD_FV_B_WHILE      5
#define SPD_FV_B_DO     6

/* edge_sort */

#define SPD_FV_E_NORMAL     0
#define SPD_FV_E_BRANCH_TRUE    1
#define SPD_FV_E_BRANCH_FALSE   2
#define SPD_FV_E_LOOPBACK   3
#define SPD_FV_E_SWITCH_CASE    4
#define SPD_FV_E_SWITCH_DEFAULT 5
#define SPD_FV_E_SWITCH_NOMATCH 6

/******************************************************************************/

#define SPD_FLOW_VIEW_VERSION       1

extern SpdDBModel Flow_view;

#endif /* _SPD_FLOW_VIEW_H */
