/* 
 * Program:             $RCSfile: Imodel.h,v $  $Revision: 30.16 $
 * 
 * Purpose:             Class definition of I-model.
 * 
 * Author:              K.Hayashi  1995/02/20
 *                      S.Yamamoto  1995/02/24
 * 
 * (C) Copyright:       K.Hayashi and S.Yamamoto  1995 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: Imodel.h,v 30.16 2003/02/20 15:12:39 yamamoto Exp yamamoto $
 */ 

#if !defined(_SAPID_I_MODEL_H)
#define _SAPID_I_MODEL_H

/* Class id. */

#define SPD_CID_PROGRAM             (SPD_FIRST_CID_I_MODEL + 0)
#define SPD_CID_FILE                (SPD_FIRST_CID_I_MODEL + 1)
#define SPD_CID_DECLARATION         (SPD_FIRST_CID_I_MODEL + 2)
#define SPD_CID_DECLARATOR          (SPD_FIRST_CID_I_MODEL + 3)
#define SPD_CID_IDENTIFIER          (SPD_FIRST_CID_I_MODEL + 4)
#define SPD_CID_OPTIONALDECL        (SPD_FIRST_CID_I_MODEL + 5)
#define SPD_CID_BLOCK               (SPD_FIRST_CID_I_MODEL + 6)
#define SPD_CID_EXPRESSION          (SPD_FIRST_CID_I_MODEL + 7)
#define SPD_CID_LABEL               (SPD_FIRST_CID_I_MODEL + 8)
#define SPD_CID_CONSTANT            (SPD_FIRST_CID_I_MODEL + 9)
#define SPD_CID_TYPE                (SPD_FIRST_CID_I_MODEL + 10)
#define SPD_CID_OPERATOR            (SPD_FIRST_CID_I_MODEL + 11)
#define SPD_CID_LIBRARY             (SPD_FIRST_CID_I_MODEL + 12)

#if (SPD_CID_LIBRARY != SPD_LAST_CID_I_MODEL)
    "Invalid configuration."
#endif

#define SPD_CID_NUM_I_MODEL \
        (SPD_LAST_CID_I_MODEL - SPD_FIRST_CID_I_MODEL + 1)

/* Relation id. */

#define SPD_RID_BLK_BLK             (SPD_FIRST_RID_I_MODEL + 0)
#define SPD_RID_BLK_DECL            (SPD_FIRST_RID_I_MODEL + 1)
#define SPD_RID_BLK_EXPR            (SPD_FIRST_RID_I_MODEL + 2)
#define SPD_RID_BLK_LABEL           (SPD_FIRST_RID_I_MODEL + 3)
#define SPD_RID_CASE_CEXPR          (SPD_FIRST_RID_I_MODEL + 4)
#define SPD_RID_CONST_REF           (SPD_FIRST_RID_I_MODEL + 5)
#define SPD_RID_DECL_DECL           (SPD_FIRST_RID_I_MODEL + 6)
#define SPD_RID_DECL_IDENT          (SPD_FIRST_RID_I_MODEL + 7)
#define SPD_RID_DECL_OPT            (SPD_FIRST_RID_I_MODEL + 8)
#define SPD_RID_DECL_TYPE           (SPD_FIRST_RID_I_MODEL + 9)
#define SPD_RID_EXPR_EXPR           (SPD_FIRST_RID_I_MODEL + 10)
#define SPD_RID_EXPR_OP             (SPD_FIRST_RID_I_MODEL + 11)
#define SPD_RID_EXPR_TYPE           (SPD_FIRST_RID_I_MODEL + 12)
#define SPD_RID_FILE_DECL           (SPD_FIRST_RID_I_MODEL + 13)
#define SPD_RID_FUNC_BODY           (SPD_FIRST_RID_I_MODEL + 14)
#define SPD_RID_FUNC_PARM           (SPD_FIRST_RID_I_MODEL + 15)
#define SPD_RID_GOTO_LABEL          (SPD_FIRST_RID_I_MODEL + 16)
#define SPD_RID_IDENT_REF           (SPD_FIRST_RID_I_MODEL + 17)
#define SPD_RID_IDENT_TYPE          (SPD_FIRST_RID_I_MODEL + 18)
#define SPD_RID_INIT_EXPR           (SPD_FIRST_RID_I_MODEL + 19)
#define SPD_RID_OP_TYPE             (SPD_FIRST_RID_I_MODEL + 20)
#define SPD_RID_PROG_FILE           (SPD_FIRST_RID_I_MODEL + 21)
#define SPD_RID_STRUCT_DECL         (SPD_FIRST_RID_I_MODEL + 22)
#define SPD_RID_TYPE_CEXPR          (SPD_FIRST_RID_I_MODEL + 23)
#define SPD_RID_TYPE_IS             (SPD_FIRST_RID_I_MODEL + 24)
#define SPD_RID_TYPE_ST             (SPD_FIRST_RID_I_MODEL + 25)
#define SPD_RID_PROT_PARM           (SPD_FIRST_RID_I_MODEL + 26)
#define SPD_RID_FUNCPTR_PARM        (SPD_FIRST_RID_I_MODEL + 27)
#define SPD_RID_DECR_TYPE           (SPD_FIRST_RID_I_MODEL + 28)
#define SPD_RID_PROG_LIB            (SPD_FIRST_RID_I_MODEL + 29)
#define SPD_RID_LIB_FILE            (SPD_FIRST_RID_I_MODEL + 30)

#if (SPD_RID_LIB_FILE != SPD_LAST_RID_I_MODEL)
    "Invalid configuration."
#endif

#define SPD_RID_NUM_I_MODEL \
        (SPD_LAST_RID_I_MODEL - SPD_FIRST_RID_I_MODEL + 1)

/* Number of all classes and relations. */

#define SPD_CRID_NUM_I_MODEL \
        (SPD_CID_NUM_I_MODEL + SPD_RID_NUM_I_MODEL)

/******************************************************************************/

#define SPD_I_MODEL_VERSION         1

extern SpdDBModel I_model;

#endif /* !defined(_SAPID_I_MODEL_H) */
