/* 
 * Program:             $RCSfile: SapidDirectory.h,v $  $Revision: 30.34 $
 * 
 * Purpose:             Directory and file names.
 * 
 * Author:              S.Yamamoto  1994/04/01
 * 
 * (C) Copyright:       S.Yamamoto  1994 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * Note:
 * If you change these macros, modify "<SAPID_TOP>/analyzer/sdb4/sdb.src".
 */

/*
 * ToDo:
 * Add prefix "SPD_" to all DIR macros.
 */

#ifndef _SAPID_DIRECTORY_H
#define _SAPID_DIRECTORY_H

#define SAPID_SDB_DIR           "SDB"

/* Globaly linked SDB. Added by S.Yamamoto 1999/04/19. */
#define SAPID_GL_SDB_DIR        "GL-SDB"

#define I_MODEL_DIR             "I-MODEL"
#define P_MODEL_DIR             "P-MODEL"
#define SPD_AREA_MODEL_DIR      "AREA-MODEL"
#define SPD_B_MODEL_DIR         "B-MODEL"
#define D_MODEL_DIR             "D-MODEL"
#define SDA4_DIR                "SDA4"
#define SPD_STMT_MODEL_DIR      "STMT-MODEL"
#define SPD_SDA_AREA_MODEL_DIR  "SDA-AREA-MODEL"
#define SPD_TYPE_VIEW_DIR       "TYPE-VIEW"
#define SPD_COMMENT_VIEW_DIR    "COMMENT-VIEW"
#define SPD_FLOW_VIEW_DIR       "FLOW-VIEW"
#define SPD_FCD_VIEW_DIR        "FCD-VIEW"
#define J_MODEL_DIR             "J-MODEL"
#define J_MODEL_TMP_DIR         "TMP-J-MODEL"

#define SAPID_SRC_DIR           "SRC"
#define SPD_TMP_SRC_DIR         "TMP-SRC"
#define PIDB_DIR                "PIDB"

#define ISDB_DIR                "ISDB"
#define DSDB_DIR                "DSDB"
#define PSDB_DIR                "PSDB"

/******************************************************************************/

/* Suffix for info. */
#define SPD_INFO_SUFFIX         ".info" 

/* Suffix for macro definition information file. */
#define PIDB_DEFINE_SUFFIX      ".define"

/* Suffix for macro expand information file. */
#define PIDB_EXPAND_SUFFIX      ".expand"

/* Suffix for #if expression information file. */
#define PIDB_IFEXPR_SUFFIX      ".ifexpr"

#define PIDB_CFILE_IFILE        "cfile_ifile"

#define SRC_PFILE_FILE          "pfile_file"

/******************************************************************************/

/* Suffix for DSDB srcfrag info. */
#define DSDB_SRCFRAG_INFO_SUFFIX    ".srcfrags"

/* Attribute name of info file of srcfrag. For only "ddbin". */
#define SRCFRAGINFO_ATTR_IFILENAME  "srcfrag"
#define SRCFRAGINFO_ATTR_OFFSET     "srcfragoffset"

#endif /* not _SAPID_DIRECTORY_H */
