/* 
 * Program:             $RCSfile: SapidOffsetOf.h,v $  $Revision: 50.1 $
 * 
 * Purpose:             Macro SPD_OFFSET_OF().
 * 
 * Author:              S.Yamamoto  2003/08/10
 * 
 * (C) Copyright:       S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: SapidOffsetOf.h,v 50.1 2003/08/10 14:10:48 yamamoto Exp yamamoto $
 */ 

#ifndef _SAPID_OFFSET_OF_H
#define _SAPID_OFFSET_OF_H

/*
 * Macro offsetof() is defined in "stddef.h".
 */

#if defined(offsetof)
#define SPD_OFFSET_OF(s, m)     offsetof(s, m)
#else
#include <X11/Intrinsic.h>
#define SPD_OFFSET_OF(s, m)     XtOffsetOf(s, m)
#endif

#define SymDataOffset(m)   SPD_OFFSET_OF(SymData, m)

#define SymDataUnionOffset(_symDataField, _union, _unionField) \
    (SymDataOffset(_symDataField) + SPD_OFFSET_OF(_union, _unionField))

#endif /* not _SAPID_OFFSET_OF_H */
