/* 
 * Program:             $RCSfile: StmtModel.h,v $  $Revision: 31.12 $
 * 
 * Purpose:
 *
 * Author:              T.Suzuki  1998/10/22
 *                      S.Yamamoto  1998/10/22
 *
 * (C) Copyright:       T.Suzuki and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: StmtModel.h,v 31.12 2003/02/20 15:12:48 yamamoto Exp yamamoto $
 */ 

#ifndef _SPD_STMT_MODEL_H
#define _SPD_STMT_MODEL_H

/* Class id. */

#define SPD_CID_STATEMENT           (SPD_FIRST_CID_STMT_MODEL + 0)

#if (SPD_CID_STATEMENT != SPD_LAST_CID_STMT_MODEL)
    "Invalid configuration."
#endif

#define SPD_CID_NUM_STMT_MODEL \
        (SPD_LAST_CID_STMT_MODEL - SPD_FIRST_CID_STMT_MODEL + 1)

/* Relation id. */

#define SPD_RID_FOR_EXPR            (SPD_FIRST_RID_STMT_MODEL + 0)
#define SPD_RID_COND_EXPR           (SPD_FIRST_RID_STMT_MODEL + 1)
#define SPD_RID_ITER_EXPR           (SPD_FIRST_RID_STMT_MODEL + 2)
#define SPD_RID_STMT_EXPR           (SPD_FIRST_RID_STMT_MODEL + 3)
#define SPD_RID_STMT_LABEL          (SPD_FIRST_RID_STMT_MODEL + 4)
#define SPD_RID_RETURN_EXPR         (SPD_FIRST_RID_STMT_MODEL + 5)
#define SPD_RID_BLOCK_DECL          (SPD_FIRST_RID_STMT_MODEL + 6)
#define SPD_RID_BLOCK_STMT          (SPD_FIRST_RID_STMT_MODEL + 7)
#define SPD_RID_CONTROL_BODY        (SPD_FIRST_RID_STMT_MODEL + 8)
#define SPD_RID_ELSE_BODY           (SPD_FIRST_RID_STMT_MODEL + 9)
#define SPD_RID_STMT_IBLOCK         (SPD_FIRST_RID_STMT_MODEL + 10)

#if (SPD_RID_STMT_IBLOCK != SPD_LAST_RID_STMT_MODEL)
    "Invalid configuration."
#endif

#define SPD_RID_NUM_STMT_MODEL \
        (SPD_LAST_RID_STMT_MODEL - SPD_FIRST_RID_STMT_MODEL + 1)

/* Number of all classes and relations. */

#define SPD_CRID_NUM_STMT_MODEL \
        (SPD_CID_NUM_STMT_MODEL + SPD_RID_NUM_STMT_MODEL)

/******************************************************************************/

/* Attribute values. */

#define STATE_BLOCK     1
#define STATE_IF        2
#define STATE_FOR       3
#define STATE_DO        4
#define STATE_WHILE     5
#define STATE_SWITCH    6
#define STATE_NORMAL    7
#define STATE_BREAK     8
#define STATE_CONTINUE  9
#define STATE_GOTO     10
#define STATE_RETURN   11

/******************************************************************************/

#define SPD_STMT_MODEL_VERSION      1

extern SpdDBModel Stmt_model;

#endif /* _SPD_STMT_MODEL_H */
