/* 
 * Program:             $RCSfile: spdFseek.h,v $  $Revision: 30.10 $
 * 
 * Purpose:
 * 
 * Author:              N.Koyama  1998/11/15
 *                      S.Yamamoto  1998/11/15
 * 
 * (C) Copyright:       N.Koyama and S.Yamamoto  1998
 *                      This file is a product of the project Sapid.
 */

#ifndef _SPD_FSEEK_H
#define _SPD_FSEEK_H

#if defined(WIN32)
#define SPD_FSEEK(s, o, w)      spdFseekWin32((s), (o), (w))
#elif defined(__CYGWIN__)
/* #define SPD_FSEEK(s, o, w)      fseek((s), (o), (w)) */
#define SPD_FSEEK(s, o, w)      spdFseekCygwin((s), (o), (w))
#else
#define SPD_FSEEK(s, o, w)      fseek((s), (o), (w))
#endif

int spdFseekWin32(FILE *stream, long int offset, int whence);
int spdFseekCygwin(FILE *stream, long int offset, int whence);

size_t spdFreadChar(void *ptr, size_t nitems, FILE *stream);

int spdGetEndian(void);

void spdOutputForShell(const char *format, int value);

#endif /* not _SPD_FSEEK_H */
