/* 
 * Program:             $RCSfile: spdStringPool.h,v $  $Revision: 30.2 $
 * 
 * Purpose:
 * 
 * Author:              N.Fukuyasu  1998/09/09
 *                      S.Yamamoto  1998/09/09
 * 
 * (C) Copyright:       N.Fukuyasu and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef SPD_STRING_POOL_H
#define SPD_STRING_POOL_H

typedef struct _SpdStringPoolList *SpdStringPoolListP;

typedef struct _SpdStringPoolList {
    SpdString           str_pool;
    SpdStringPoolListP  next;
} SpdStringPoolList;

typedef struct _SpdStringPool {
    SpdStringPoolListP  pool_list;
    size_t              pool_size;
    size_t              space_size;
    SpdString           current_pos;
} SpdStringPool;

SpdStringPool *spdStrPoolInit(size_t size);
SpdString spdStrPoolCopy(SpdStringPool *pool, SpdString str);
SpdString spdStrPoolFastCopy(SpdStringPool *pool, SpdString str);
void spdStrPoolFree(SpdStringPool *pool);

#endif /* SPD_STRING_POOL_H */
