/* 
 * Program:             $RCSfile: version.h,v $  $Revision: 30.2267 $
 * 
 * Purpose:             Version information of the project Sapid.
 * 
 * Author:              S.Yamamoto  1994/04/01
 * 
 * (C) Copyright:       S.Yamamoto  1994 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: version.h,v 30.2267 2003/11/26 23:27:12 yamamoto Exp yamamoto $
 */ 

#ifndef _SAPID_VERSION_H
#define _SAPID_VERSION_H

#define SapidVersion        5
#define SapidRevision       285
#define SapidPatchLevel     0

/* 
 * SapidSDBVersion:
 * 
 * 1: In ER notation, 1991/09/30.
 * 2: In OMT notation, 1995/04/01.
 * 3: Added an attribute length to class "constant", ver. 1.233, 1996/05/25.
 * 4: Added class OPT_FUNCPTR.
 *    Added relations PROT_PARM and FUNCPTR_PARM, ver. 2.2, 1997/05/18.
 * 5: Deleted an attribute "document" from classes "file", "constant"
 *    and "type", ver. 2.372, 1997/10/29.
 * 6: Deleted C-model's attribute "status" from all relations.
 *    Deleted C-moddel's attributes "p_file_id", "order" and "o_declaration_id"
 *    from relation "file_decl". Deleted an attributes "name"
 *    from class "constant", ver. 2.385, 1997/10/31.
 * 7: Added attribute to "mbody_mdecla" and changed attribute names
 *    in P-model, ver. 2.431, 1997/11/11.
 * 8: Deleted an attribute "offset" of relation "hfile_file",
 *    ver. 2.437, 1997/11/17.
 * 9: Added an attribute "scope" to class "identifier", ver. 2.537, 1998/01/25.
 * 
 * 10: Deleted an attribute "offset" from relation "mcall_mname",
 *     ver. 2.573, 1998/02/10.
 * 11: Use an attribute "scope" in class "identifier" for ISDB,
 *     ver. 2.618, 1998/03/11.
 * 12: Object identifiers start from 0, ver. 2.660, 1998/05/05.
 * 13: Temporarily, ver. 2.790.10, 1998/07/04.
 * 14: Deleted separators in ISDB, ver. 2.794, 1998/07/05.
 * 15: Modified OBJ_XXX_ID_BASE in "PIDB4.h", ver. 2.795, 1998/07/05.
 * 16: Added class "iblock". Added relations "pblock_iblock" and
 *     "ifile_iblock", ver. 2.817, 1998/07/10.
 * 17: Added EXPR_SORT_{BIT,SHIFT,COMPARE} in "AR3Attr.h",
 *     ver. 2.830, 1998/07/10.
 * 18: Modified macro SpdObjIValN as 6, ver. 2.874.1, 1998/08/20.
 * 19: Modified order of attributes drastically, ver. 3.36, 1998/10/12.
 * 20: Deleted an attribute "offset" from relation "op_type",
 *     ver. 3.77, 1998/11/05.
 * 
 * 21: Added SAPID_VALIDATION_FILE_[12] for checking validation of SDB,
 *     ver. 3.331.1, 1999/06/12.
 * 22: Added class "library" and relations "prog_lib" and "lib_file",
 *     ver. 3.358.1, 1999/07/06. 
 * 23: Fixed a careless mistake, ver. 3.384, 1999/07/28.
 * 24: Command "sdbin4" doesn't output classes "program" and "file",
 *     and relation "prog_file", ver. 3.416, 1999/08/28.
 * 25: Added quasi-relation "pfile_file", ver. 3.514.1, 1999/11/27.
 * 26: Save attribute as "<VALUE><SDB_ATTR_SEPARATOR>", ver. 3.369, 2000/03/18.
 * 27: Byteorder independent format for binary mode, ver. 3.796, 2000/09/13.
 * 28: Deleted obsolete OP_{TRI,PAR,ARRAY}, ver. 3.908, 2001/03/15.
 * 29: Modified relation "point_to" into "sarea_sarea" in SareaModel,
 *     ver. 3.974, 2001/05/29.
 * 30: Correct careless mistakes in "Model/Imodel/Imodel.c",
 *     ver. 4.135, 2001/09/28.
 * 31: Added the new view CommentView, ver. 4.177, 2001/10/27.
 * 32: Modified an attribute of the relation "class_argument" in J-model,
 *     ver. 4.179, 2001/10/27.
 * 33: Modified a macro SPD_BIT_WIDTH_ID as 23, ver. 4.318.1, 2002/03/03.
 * 34: Modified PIDB (DefineInfo) format, ver. 4.357, 2002/05/02.
 * 35: Added PIDB info, ver. 4.360, 2002/05/04.
 * 36: Modified PIDB (ExpandInfo, IfExprInfo) format, ver. 4.363, 2002/05/05.
 * 37: Deleted macro SAPID_INFO_FILE (".SapidVerInfo"), ver. 4.368, 2002/05/06.
 * 38: Added a macro CONST_WCHAR, ver. 4.446, 2002/07/25.
 * 39: Deleted a macro CONST_EXPRESSION, ver. 4.448, 2002/07/26.
 * 40: Modified a macro SPD_BIT_WIDTH_ID as 22, ver. 4.449.1, 2002/07/27.
 * 41: Deleted class "Initializer" in J-model, ver. 4.860, 2003/02/21.
 *
 * Note: C.f. "<SAPID_TOP>/Japid3/Japid/Freja/Version.java".
 */

#define SapidSDBVersion     41

/* 
 * SapidPIDBVersion:
 * 
 * 1: Original.
 * 2: Deleted titles from DefineInfo and ExpandInfo files,
 *    ver. 3.409.2, 1999/08/24.
 */

#define SapidPIDBVersion    2

#define SAPID_VALIDATION_FILE_1     ".isValidSDB-1"
#define SAPID_VALIDATION_FILE_2     ".isValidSDB-2"

#endif /* not _SAPID_VERSION_H */
