<?xml version="1.0" encoding="Shift_JIS"?>

<!--
# 
# Program:		$RCSfile: sourceView.xsl,v $  $Revision: 50.7 $
# 
# Purpose:		
# 
# Author:		Y.Sawada  2003/10/01
# Author:		S.Yamamoto  2003/10/01
# 
# (C) Copyright:	S.Yamamoto  2003
#			This file is a product of the project Sapid.
# 
-->

<!--
    $Id: sourceView.xsl,v 50.7 2003/11/26 23:25:20 yamamoto Exp yamamoto $
-->  

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:output method="xml" omit-xml-declaration="yes"/>
  <xsl:param name="packageDir"/>

  <xsl:template match="/">
    <xsl:for-each select="//nl">
      <xsl:if test="position()=last()">
        <xsl:comment><xsl:value-of select="@line" /></xsl:comment>
      </xsl:if>
    </xsl:for-each>
    <div id="source">
      <xsl:apply-templates />
      <div id="endFile" class="vspace"><xsl:text> </xsl:text></div>
    </div>
  </xsl:template>
  
  <xsl:template match="File[@id != '']">
    <pre>
      <xsl:attribute name="id"><xsl:value-of select="@id"/></xsl:attribute>
      <xsl:attribute name="class"><xsl:value-of select="name()"/></xsl:attribute>
      <xsl:comment> Don't remove this comment! </xsl:comment>
      <xsl:apply-templates />
    </pre>
  </xsl:template>
  
  <xsl:template match="Class[@id != '']|Intf[@id != '']|Ctor[@id != '']|Method[@id != '']|SInit[@id != '']|Field[@id != '']|Local[@id != '']|Param[@id != '']|Package[@id != '']|Stmt[@id != '']|Label[@id != '']|SwLabel[@id != '']|Expr[@id != '']|comment[@id != '']|ImplOpt[@id != '']|ExtdOpt[@id = '']|ThrwOpt[@id != '']|Import[@id != '']">
    <span>
      <xsl:attribute name="id"><xsl:value-of select="@id"/></xsl:attribute>
      <xsl:attribute name="class"><xsl:value-of select="name()"/></xsl:attribute>
      <xsl:apply-templates />
    </span>
  </xsl:template>
  
  <xsl:template match="QName[@id != '']">
    <span>
      <xsl:attribute name="id"><xsl:value-of select="@id"/></xsl:attribute>
      <xsl:attribute name="class"><xsl:value-of select="name()"/></xsl:attribute>
      <xsl:value-of select="."/>
    </span>
  </xsl:template>

  <xsl:template match="ident[@* = @defid]">
    <a>
      <xsl:attribute name="class">
        <xsl:value-of select="name(/descendant::*[@id = current()/@defid])"/>
      </xsl:attribute>
      <xsl:attribute name="href">
        <xsl:text>javascript:selfRef('</xsl:text>
        <xsl:value-of select="@defid"/>
        <xsl:text>')</xsl:text>
      </xsl:attribute>
      <xsl:apply-templates />
    </a>
  </xsl:template>

  <xsl:template match="ident[@file and @defid]">
    <a>
      <xsl:attribute name="class">
        <xsl:value-of
          select="name(document(concat($packageDir, @file, '.xml'))/descendant::*[@id = current()/@defid])"/>
      </xsl:attribute>
      <xsl:attribute name="href">
        <xsl:text>fileset.jsp?file=</xsl:text>
        <xsl:value-of select="substring-before(@file, '.java')"/>
        <xsl:text>&amp;id=</xsl:text>
        <xsl:value-of select="@defid"/>
      </xsl:attribute>
      <xsl:apply-templates />
    </a>
  </xsl:template>

<!--  <xsl:template match="op|kw|literal|ident[@defid = '']"> -->
  <xsl:template match="op|kw|literal|ident">
    <span>
      <xsl:attribute name="class"><xsl:value-of select="name()"/></xsl:attribute>
      <xsl:apply-templates />
    </span>
  </xsl:template>
  
</xsl:stylesheet>
