# 
# Program:              $RCSfile: SetUp.src,v $  $Revision: 30.37 $
# 
# Purpose:              Set up your environment.
# 
# Author:               H.Ariga  1994/10/15
#                       S.Yamamoto  1994/10/15
# 
# (C) Copyright:        H.Ariga and S.Yamamoto  1994 - 2003
#                       This file is a product of the project Sapid.
# 

# 
# $Id: SetUp.src,v 30.37 2003/10/03 15:09:38 yamamoto Exp yamamoto $
# 

# 
# Add below lines to your ".cshrc", if you use csh or tcsh.
# 
# if (-r "/usr/local/Sapid/lib/SetUp") then
#     source "/usr/local/Sapid/lib/SetUp"
# endif
# 
# Add below lines to your ".profile", if you use sh or bash.
# 
# if [ -r "/usr/local/Sapid/lib/SetUp" ]; then
#     . "/usr/local/Sapid/lib/SetUp.sh"
# fi
# 

# 
# For bourne shell.
# 

# export SAPID_BINDIR
# export SAPID_LIBDIR
# export SAPID_MKHTML_LIBDIR
# export SAPID_SAT_LIBDIR
# export SAPID_SDB_CONFDIR
# export SAPID_SIP_LIBDIR
# export SAPID_TCLAR_LIBDIR

# export SPD_DEF_BEFORE
# export SPD_DEF_AFTER
# export SPD_DEF_ANSI_BEFORE
# export SPD_DEF_ANSI_AFTER
# export SPD_DEF_GCC
# export SPD_INCLUDE_PATH

# export CLASSPATH
# export PURIFYOPTIONS
# export TCL_LIBRARY
# export TK_LIBRARY

# 
# Set path variable.
# 

set path = ("/usr/local/Sapid/bin" $path)

# 
# Set Sapid environment variables.
# 

setenv SAPID_BINDIR         "/usr/local/Sapid/bin"
setenv SAPID_LIBDIR         "/usr/local/Sapid/lib"
setenv SAPID_SDB_CONFDIR    "/usr/local/Sapid/lib"

setenv SAPID_SAT_LIBDIR     "/usr/local/Sapid/lib"
setenv SAPID_SDA_LIBDIR     "/usr/local/Sapid/lib"
setenv SAPID_SIP_LIBDIR     "/usr/local/Sapid/lib"
setenv SAPID_SPE_LIBDIR     "/usr/local/Sapid/lib"
setenv SAPID_TCLAR_LIBDIR   "/usr/local/Sapid/lib"

setenv SAPID_MKHTML_LIBDIR  "/usr/local/Sapid/lib/spdMkHtml"

setenv SPD_INCLUDE_PATH     "-I/usr/local/Sapid/fixed-include"

# 
# Set general environment variables.
# 

# For only Cygwin environment.
# setenv TCL_LIBRARY          "SapidTclShareDir"
# setenv TK_LIBRARY           "SapidTkShareDir"

if (${?TEXINPUTS} == 1) then
    setenv TEXINPUTS "/usr/local/Sapid/lib/tex:${TEXINPUTS}"
else
    setenv TEXINPUTS "/usr/local/Sapid/lib/tex"
endif

if (${?XAPPLRESDIR} == 1) then
    setenv XAPPLRESDIR "/usr/local/Sapid/lib/X11/app-defaults:${XAPPLRESDIR}"
else
    setenv XAPPLRESDIR "/usr/local/Sapid/lib/X11/app-defaults"
endif

# 
# Set Purify environment variables.
# 

if (-r "/usr/local/Sapid/src") then
    if (${?PURIFYOPTIONS} == 1) then
        setenv PURIFYOPTIONS "-user-path=/usr/local/Sapid/src ${PURIFYOPTIONS}"
    else
        setenv PURIFYOPTIONS "-user-path=/usr/local/Sapid/src"
    endif
endif

# 
# Japid.
# 

if (${?CLASSPATH} == 1) then
    setenv CLASSPATH "/usr/local/Sapid/class/Japid3.jar:/usr/local/Sapid/class/Wapid.jar:/usr/local/Sapid/class/java-getopt-1.0.9.jar:/usr/local/Sapid/class/jtool-1.2.jar:${CLASSPATH}"
else
    setenv CLASSPATH "/usr/local/Sapid/class/Japid3.jar:/usr/local/Sapid/class/Wapid.jar:/usr/local/Sapid/class/java-getopt-1.0.9.jar:/usr/local/Sapid/class/jtool-1.2.jar:."
endif

if (${?JAVA_HOME} == 1) then
    setenv CLASSPATH "${JAVA_HOME}/lib/tools.jar:${CLASSPATH}"
endif

# unlimit descriptors

# 
# Set PIDB environment variables.
# 

if (! -x "/usr/local/Sapid/bin/sub/getGccOpts") then
    exit
endif

setenv SPD_DEF_BEFORE       "`/usr/local/Sapid/bin/sub/getGccOpts -D`"
setenv SPD_DEF_AFTER        "`/usr/local/Sapid/bin/sub/getGccOpts -I`"

setenv SPD_DEF_ANSI_BEFORE  "`/usr/local/Sapid/bin/sub/getGccOpts -D -a`"
setenv SPD_DEF_ANSI_AFTER   "`/usr/local/Sapid/bin/sub/getGccOpts -I -a`"

setenv SPD_DEF_GCC          "`/usr/local/Sapid/bin/sub/getGccOpts -D -g`"
setenv SPD_INCLUDE_PATH     "-I/usr/local/Sapid/fixed-include"

# Use include files fixed by gcc in Solaris.

if (-x /bin/uname) then
    if ("`/bin/uname`" == "SunOS") then
        setenv SPD_DEF_AFTER "`/usr/local/Sapid/bin/sub/getGccOpts -I -l` ${SPD_DEF_AFTER}"
        setenv SPD_DEF_ANSI_AFTER "`/usr/local/Sapid/bin/sub/getGccOpts -I -a -l` ${SPD_DEF_ANSI_AFTER}"
    endif
endif
