# 
# Program:              $RCSfile: SetUp.src,v $  $Revision: 30.37 $
# 
# Purpose:              Set up your environment.
# 
# Author:               H.Ariga  1994/10/15
#                       S.Yamamoto  1994/10/15
# 
# (C) Copyright:        H.Ariga and S.Yamamoto  1994 - 2003
#                       This file is a product of the project Sapid.
# 

# 
# $Id: SetUp.src,v 30.37 2003/10/03 15:09:38 yamamoto Exp yamamoto $
# 

# 
# Add below lines to your ".cshrc", if you use csh or tcsh.
# 
# if (-r "/usr/local/Sapid/lib/SetUp") then
#     source "/usr/local/Sapid/lib/SetUp"
# endif
# 
# Add below lines to your ".profile", if you use sh or bash.
# 
# if [ -r "/usr/local/Sapid/lib/SetUp" ]; then
#     . "/usr/local/Sapid/lib/SetUp.sh"
# fi
# 

# 
# For bourne shell.
# 

export SAPID_BINDIR
export SAPID_LIBDIR
export SAPID_MKHTML_LIBDIR
export SAPID_SAT_LIBDIR
export SAPID_SDB_CONFDIR
export SAPID_SIP_LIBDIR
export SAPID_TCLAR_LIBDIR

export SPD_DEF_BEFORE
export SPD_DEF_AFTER
export SPD_DEF_ANSI_BEFORE
export SPD_DEF_ANSI_AFTER
export SPD_DEF_GCC
export SPD_INCLUDE_PATH

export CLASSPATH
export PURIFYOPTIONS
export TCL_LIBRARY
export TK_LIBRARY

# 
# Set path variable.
# 

PATH=/usr/local/Sapid/bin:${PATH}

# 
# Set Sapid environment variables.
# 

SAPID_BINDIR="/usr/local/Sapid/bin"
SAPID_LIBDIR="/usr/local/Sapid/lib"
SAPID_SDB_CONFDIR="/usr/local/Sapid/lib"

SAPID_SAT_LIBDIR="/usr/local/Sapid/lib"
SAPID_SDA_LIBDIR="/usr/local/Sapid/lib"
SAPID_SIP_LIBDIR="/usr/local/Sapid/lib"
SAPID_SPE_LIBDIR="/usr/local/Sapid/lib"
SAPID_TCLAR_LIBDIR="/usr/local/Sapid/lib"

SAPID_MKHTML_LIBDIR="/usr/local/Sapid/lib/spdMkHtml"

SPD_INCLUDE_PATH="-I/usr/local/Sapid/fixed-include"

# 
# Set general environment variables.
# 

# For only Cygwin environment.
# TCL_LIBRARY="SapidTclShareDir"
# TK_LIBRARY="SapidTkShareDir"

if [ "${TEXINPUTS}" != "" ]; then
    TEXINPUTS="/usr/local/Sapid/lib/tex:${TEXINPUTS}"
else
    TEXINPUTS="/usr/local/Sapid/lib/tex"
fi

if [ "${XAPPLRESDIR}" != "" ]; then
    XAPPLRESDIR="/usr/local/Sapid/lib/X11/app-defaults:${XAPPLRESDIR}"
else
    XAPPLRESDIR="/usr/local/Sapid/lib/X11/app-defaults"
fi

# 
# Set Purify environment variables.
# 

if [ -r "/usr/local/Sapid/src" ]; then
    if [ "${PURIFYOPTIONS}" != "" ]; then
        PURIFYOPTIONS="-user-path=/usr/local/Sapid/src ${PURIFYOPTIONS}"
    else
        PURIFYOPTIONS="-user-path=/usr/local/Sapid/src"
    fi
fi

# 
# Japid.
# 

if [ "${CLASSPATH}" != "" ]; then
    CLASSPATH="/usr/local/Sapid/class/Japid3.jar:/usr/local/Sapid/class/Wapid.jar:/usr/local/Sapid/class/java-getopt-1.0.9.jar:/usr/local/Sapid/class/jtool-1.2.jar:${CLASSPATH}"
else
    CLASSPATH="/usr/local/Sapid/class/Japid3.jar:/usr/local/Sapid/class/Wapid.jar:/usr/local/Sapid/class/java-getopt-1.0.9.jar:/usr/local/Sapid/class/jtool-1.2.jar:."
fi

if [ "${JAVA_HOME}" != "" ]; then
    CLASSPATH="${JAVA_HOME}/lib/tools.jar:${CLASSPATH}"
fi

# unlimit descriptors

# 
# Set PIDB environment variables.
# 

if [ ! -x "/usr/local/Sapid/bin/sub/getGccOpts" ]; then
    return
fi

SPD_DEF_BEFORE="`/usr/local/Sapid/bin/sub/getGccOpts -D`"
SPD_DEF_AFTER="`/usr/local/Sapid/bin/sub/getGccOpts -I`"

SPD_DEF_ANSI_BEFORE="`/usr/local/Sapid/bin/sub/getGccOpts -D -a`"
SPD_DEF_ANSI_AFTER="`/usr/local/Sapid/bin/sub/getGccOpts -I -a`"

SPD_DEF_GCC="`/usr/local/Sapid/bin/sub/getGccOpts -D -g`"
SPD_INCLUDE_PATH="-I/usr/local/Sapid/fixed-include"

# Use include files fixed by gcc in Solaris.

if [ -x /bin/uname ]; then
    if [ "`/bin/uname`" = "SunOS" ];then
        SPD_DEF_AFTER="`/usr/local/Sapid/bin/sub/getGccOpts -I -l` ${SPD_DEF_AFTER}"
        SPD_DEF_ANSI_AFTER="`/usr/local/Sapid/bin/sub/getGccOpts -I -a -l` ${SPD_DEF_ANSI_AFTER}"
    fi
fi
